//
//  NSDataReader.h
//  SQLKit
//
//  Created by Richard Penwell on 2/3/10.
//  Copyright 2010 Richard Penwell. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface NSDataReader : NSObject {
	NSData* data;
	NSUInteger position;
}

@property NSUInteger position;

+ (NSDataReader*)readerWithData:(NSData*)theData;

- (NSDataReader*)initWithData:(NSData*)theData;

- (UInt8)readByte;
- (UInt16)readUShort;
- (UInt32)readUInt;

- (UInt16)readUShortWithByteOrder:(CFByteOrder)order;
- (UInt32)readUIntWithByteOrder:(CFByteOrder)order;
- (NSData*)readDataWithLength:(NSUInteger)length;
- (NSData*)remainder;

- (BOOL)hasMoreData;

@end
