//
//  NSMutableData_Extensions.h
//  SQLKit
//
//  Created by Richard Penwell on 2/3/10.
//  Copyright 2010 Richard Penwell. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@interface NSIndexedLengthStringEntry : NSObject
{
	NSData* data;
	NSUInteger position;
}

@property (retain, nonatomic) NSData* data;
@property (nonatomic) NSUInteger position;

@end


@interface NSMutableData (Extensions)

- (void)appendByte:(UInt8)byte;
- (void)appendUShort:(UInt16)aShort;
- (void)appendUInt:(UInt32)aInt;
- (void)appendUShort:(UInt16)aShort byteOrder:(CFByteOrder)order;
- (void)appendUInt:(UInt32)aInt byteOrder:(CFByteOrder)order;

- (void)appendUShortIndexedLengthString:(NSString*)string withDataSegment:(NSMutableArray*)data;
- (void)appendUShortIndexedLengthData:(NSData*)dataObject withDataSegment:(NSMutableArray*)data;
- (void)writeDataSegment:(NSArray*)data;

- (void)setUShort:(UInt16)aShort atIndex:(NSUInteger)index;
- (void)setUInt:(UInt32)aInt atIndex:(NSUInteger)index;
@end
