//
//  TDSLoginPacket.m
//  SQLKit
//
//  Created by Richard Penwell on 2/7/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "TDSLoginPacket.h"


@implementation TDSLoginPacket

- (id)init
{
	if (self = [super init])
	{
		tdsVersion = 0x71000001;
		packetSize = 0x1000;
		databaseName = nil;
		language = @"us_english";
	}
	
	return self;
}

- (NSData*)encryptedPassword
{
	NSMutableData* clearPassword = [NSMutableData dataWithCapacity:([password length] * 2)];
	NSMutableData* encryptedPassword = [NSMutableData new];
	
	[clearPassword appendBytes:[password cStringUsingEncoding:NSUnicodeStringEncoding] length:([password length] * 2)];
	const unsigned char *clearBytes = [clearPassword bytes];
	
	for (int i = 0; i < [clearPassword length]; i++)
		[encryptedPassword appendByte:(((clearBytes[i] << 4) | (clearBytes[i] >> 4)) ^ 0xA5)];
	
	return [encryptedPassword autorelease];
}

- (NSData*)createPacket
{
	NSMutableData* packetData = [NSMutableData new];
	
	// Write out a nil length which we will patch at the end.
	[packetData appendUInt:0];
	[packetData appendUInt:tdsVersion];
	[packetData appendUInt:packetSize];
	[packetData appendUInt:clientVersion];
	[packetData appendUInt:getpid()];
	[packetData appendUInt:0];
	[packetData appendByte:0xE0];
	[packetData appendByte:0x03];
	[packetData appendByte:0x00];
	[packetData appendByte:0x00];
	[packetData appendUInt:0xFFFFFF88];
	[packetData appendUInt:0x00000436];
	
	NSString* machineHostname = [[NSProcessInfo processInfo] hostName];
	NSMutableArray* appendedData = [NSMutableArray new];
	
	[packetData appendUShortIndexedLengthString:machineHostname withDataSegment:appendedData];
	[packetData appendUShortIndexedLengthString:username withDataSegment:appendedData];
	[packetData appendUShortIndexedLengthData:[self encryptedPassword] withDataSegment:appendedData];
	[packetData appendUShortIndexedLengthString:applicationName withDataSegment:appendedData];
	[packetData appendUShortIndexedLengthString:serverName withDataSegment:appendedData];
	[packetData appendUInt:0];
	[packetData appendUShortIndexedLengthString:@"MSSQL.sqlProvider" withDataSegment:appendedData];
	[packetData appendUShortIndexedLengthString:language withDataSegment:appendedData];
	[packetData appendUShortIndexedLengthString:databaseName withDataSegment:appendedData];
	[packetData appendData:[[NSProcessInfo processInfo] macAddress]];
	[packetData appendUShortIndexedLengthString:nil withDataSegment:appendedData];
	[packetData appendUShortIndexedLengthString:attachDatabaseFile withDataSegment:appendedData];	
	[packetData writeDataSegment:appendedData];
	[appendedData release];
	// Fixup the length
	[packetData setUInt:[packetData length] atIndex:0];
	
	return [packetData autorelease];
}

- (void)setDatabaseName:(NSString *)theDatabaseName
{
	if (theDatabaseName == nil) { databaseName = nil; return; }
	if (![theDatabaseName hasPrefix:@"["] || ![theDatabaseName hasSuffix:@"]"])
		databaseName = [NSString stringWithFormat:@"[%@]", theDatabaseName];
	else
		databaseName = [theDatabaseName retain];
}

- (NSString*)databaseName { return databaseName; }

@synthesize username, password, serverName, clientProcessId, connectionId, attachDatabaseFile, changePassword, clientVersion, tdsVersion, packetSize, applicationName, libraryName, language;

@end
