//
//  TDSResultPacket.h
//  SQLKit
//
//  Created by Richard Penwell on 2/9/10.
//  Copyright 2010 Richard Penwell. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "TDSResultPacketDelegate.h"
#import "TDSTokenStreamParser.h"

@interface TDSResultPacket : NSObject {
	id<TDSResultPacketDelegate> delegate;
	NSMutableArray* columnDefinitions;
	NSData* remainderData;
	TDSTokenStreamParser* tokenParser;
}

@property (nonatomic, retain) id<TDSResultPacketDelegate> delegate;

+ (TDSResultPacket*)resultPacketWithDelegate:(id<TDSResultPacketDelegate>)delegate data:(NSData*)data;

- (id)initWithDelegate:(id<TDSResultPacketDelegate>)newDelegate data:(NSData*)data;
- (void)appendAdditionalData:(NSData*)data;
- (void)completePacket;

@end
