//
//  TDSResultPacket.m
//  SQLKit
//
//  Created by Richard Penwell on 2/9/10.
//  Copyright 2010 Richard Penwell. All rights reserved.
//

#import "TDSResultPacket.h"


@interface TDSResultPacket (Private)

- (void)processIncomingData:(NSData*)data;

@end

@implementation TDSResultPacket

@synthesize delegate;

+ (TDSResultPacket*)resultPacketWithDelegate:(id<TDSResultPacketDelegate>)delegate data:(NSData*)data
{
	return [[TDSResultPacket alloc] initWithDelegate:delegate data:data];
}

- (id)initWithDelegate:(id<TDSResultPacketDelegate>)newDelegate data:(NSData*)data
{
	if (self = [super init])
	{
		[self setDelegate:newDelegate];
		[self processIncomingData:data];
	}
	
	return self;
}

- (void)appendAdditionalData:(NSData*)data
{
	[self processIncomingData:data];
}

- (void)processIncomingData:(NSData*)data
{
	if (remainderData)
	{
		NSMutableData* newData = [NSMutableData dataWithData:remainderData];
		[newData appendData:data];
		data = newData;
	}
	
	
}

- (void)completePacket
{
}

@end
