/*
 *  TDSStructures.h
 *  SQLKit
 *
 *  Created by Richard Penwell on 2/3/10.
 *  Copyright 2010 Richard Penwell. All rights reserved.
 *
 */

enum {
	TDSPacketTypeBatch = 0x01,
	TDSPacketTypeLoginPre7 = 0x02,
	TDSPacketTypeRPC = 0x03,
	TDSPacketTypeResponse = 0x04,
	TDSPacketTypeAttentionSignal = 0x06,
	TDSPacketTypeBulkLoad = 0x07,
	TDSPacketTypeTransactionRequest = 0x0E,
	TDSPacketTypeLogin = 0x10,
	TDSPacketTypeSSPI = 0x11,
	TDSPacketTypePreLogin = 0x12
};
typedef UInt8 TDSPacketType;

enum {
	TDSStatusNormal = 0x00,
	TDSStatusEndOfMessage = 0x01,
	TDSStatusIgnore = 0x02,
	TDSStatusReset = 0x08,
	TDSStatusResetKeepingTransaction = 0x10
};
typedef UInt8 TDSStatus;

struct TDSHeader {
	TDSPacketType type;
	TDSStatus status;
	UInt16 length;
	UInt16 sessionIdentifier;
	UInt8 sequanceNumber;
	UInt8 window;
};
typedef struct TDSHeader TDSHeader;

struct TDSPreloginToken {
	UInt8 type;
	UInt16 offset;
	UInt16 length;
};
typedef struct TDSPreloginToken TDSPreloginToken;

enum {
	TDSPreloginTokenTypeVersion = 0x00,
	TDSPreloginTokenTypeEncryption = 0x01,
	TDSPreloginTokenTypeInstance = 0x02,
	TDSPreloginTokenTypeThreadId = 0x03,
	TDSPreloginTokenTypeMutipleActiveResultSet = 0x04,
	TDSPreloginTokenTypeTerminator = 0xFF
};
typedef UInt8 TDSPreloginTokenType;

enum {
	TDSEncryptionDisabled = 0x00,
	TDSEncryptionAvailable = 0x01,
	TDSEncryptionNotAvailable = 0x02,
	TDSEncryptionRequired = 0x03
};

enum {
	TDSMultipleActiveResultsSetDisabled = 0x00,
	TDSMultipleActiveResultsSetEnabled = 0x01
};

extern NSString* kTDSServerVersion;
extern NSString* kTDSServerBuild;
extern NSString* kTDSEncryptionType;
extern NSString* kTDSInstanceName;
extern NSString* kTDSThreadId;
extern NSString* kTDSMultipleActiveResultSet;
