//
//  TDSConnectionTest.m
//  SQLKit
//
//  Created by Richard Penwell on 2/2/10.
//  Copyright 2010 Richard Penwell. All rights reserved.
//

#import "TDSConnectionTest.h"
#import "TDSConnection.h"

@implementation TDSConnectionTest

- (void)testCreationOfTDSConnection
{
	NSHost* host = [NSHost hostWithName:@"g8sql1.g8wave.com"];
	[TDSConnection connectionWithHost:host];
}

- (void)testOpeningOfTDSConnection
{
	NSHost* host = [NSHost hostWithName:@"g8sql1.g8wave.com"];
	TDSConnection* connection = [TDSConnection connectionWithHost:host];
	[connection open];
}

- (void)testStreamStatusAfterOpen
{
	NSHost* host = [NSHost hostWithName:@"g8sql1.g8wave.com"];
	TDSConnection* connection = [TDSConnection connectionWithHost:host];
	[connection open];
	
	STAssertEquals((NSStreamStatus)NSStreamStatusOpening, [connection streamStatus],
				   @"streamStatus should be opening after calling -[TDSConnection open] but was %u", [connection streamStatus]);
	
	[[NSRunLoop currentRunLoop] runUntilDate:[NSDate dateWithTimeIntervalSinceNow:10]];
}

@end
