//
//  SQLConnectionPool.h
//  SQLKit
//
//  Created by Richard Penwell on 2/1/10.
//  Copyright 2010 Richard Penwell. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "SQLConnection.h"

@interface SQLConnectionPool : NSObject {
	NSMutableArray* connections;
	SQLConnectionString* connectionString;
}

- (SQLConnectionPool*)initWithConnectionString:(SQLConnectionString*)connectionString;
- (SQLConnectionPool*)initWithProvider:(NSString*)connectionProvider 
			  providerConnectionString:(NSString*)providerConnectionString;

+ (SQLConnectionPool*)connectionPoolWithConnectionString:(SQLConnectionString*)connectionString;

- (SQLConnection*)createConnection;
- (void)drain;

@property (readonly) SQLConnectionString* connectionString;

@end
