//
//  SQLConnectionProvider.m
//  SQLKit
//
//  Created by Richard Penwell on 2/1/10.
//  Copyright 2010 Richard Penwell. All rights reserved.
//

#import "SQLConnectionProvider.h"


@implementation SQLConnectionProvider

+ (SQLConnectionProvider*)connectionProviderWithBundle:(NSBundle*)bundle
{
	return [[SQLConnectionProvider alloc] initWithBundle:bundle];
}

+ (SQLConnectionProvider*)connectionProviderWithName:(NSString*)name
{
	return [[SQLConnectionProvider alloc] initWithName:name];
}

- (SQLConnectionProvider*)initWithBundle:(NSBundle*)bundle
{
	if (self = [super init])
	{
		providerBundle = bundle;
		[bundle load];
	}
	
	return self;
}

- (SQLConnectionProvider*)initWithName:(NSString*)name
{
	NSURL* bundleUrl = [NSURL URLWithString:
						[NSString stringWithFormat:@"file:///Library/SQL Providers/%@.provider", name]];
	NSBundle* bundle = [NSBundle bundleWithURL:bundleUrl];
	return [self initWithBundle:bundle];
}

- (Class)connectionClass
{
	return [providerBundle principalClass];
}

@end
